//////////////////////////////////////////////////////////////////////////////
//
// Copyright  2002-2004, Microsoft Corporation.  All rights reserved.
//
// File: Bookmarkmenu.js
//
// Description: Implements functionality associated with the viewer's bookmark menu.
//
//////////////////////////////////////////////////////////////////////////////

var ADD_BOOKMARK_WINDOW_HEIGHT = 150;
var ADD_BOOKMARK_WINDOW_WIDTH = 439;
var MANAGE_BOOKMARK_WINDOW_HEIGHT = 331;
var MANAGE_BOOKMARK_WINDOW_WIDTH = 495;
var g_oAddBookmarkWin = null;
var g_oManageBookmarkWin = null;

//--------------------------------------------------------------------
// Function: AddBookmark
//
// Purpose: Opens a simulated modal dialog for adding bookmarks.
//
// Parameters: None
//	
// Returns: None
//--------------------------------------------------------------------
function AddBookmark()
{
	try
	{
		if (!g_oAddBookmarkWin || g_oAddBookmarkWin.closed)
		{
			var xOffset = (screen.width - ADD_BOOKMARK_WINDOW_WIDTH)/2, yOffset = (screen.height - ADD_BOOKMARK_WINDOW_HEIGHT)/2;
   			var sWinProps = "toolbar=no,location=no,directories=no,menubar=no,scrollbars=yes,resizable=no,status=no,height=" + ADD_BOOKMARK_WINDOW_HEIGHT + ",width=" + ADD_BOOKMARK_WINDOW_WIDTH + ",left=" + xOffset + ",top=" + yOffset;

			var sURL = "addbookmark.htm";

    			g_oAddBookmarkWin = window.open(sURL,"",sWinProps);
			if (g_oAddBookmarkWin)
			{
				window.attachEvent("onunload",CloseWindow);
				document.body.attachEvent("onfocus",StealWindowFocus);
				window.attachEvent("onfocus",StealWindowFocus);
			}
		}
		g_oAddBookmarkWin.focus();
	}
	catch(e)
	{
	}
}

//--------------------------------------------------------------------
// Function: ManageBookmarks
//
// Purpose: Opens a simulated modal dialog for managing bookmarks.
//
// Parameters: None
//	
// Returns: None
//--------------------------------------------------------------------
function ManageBookmarks()
{
	try
	{
		if (!g_oManageBookmarkWin || g_oManageBookmarkWin.closed)
		{
			var xOffset = (screen.width - MANAGE_BOOKMARK_WINDOW_WIDTH)/2, yOffset = (screen.height - MANAGE_BOOKMARK_WINDOW_HEIGHT)/2;
   			var sWinProps = "toolbar=no,location=no,directories=no,menubar=no,scrollbars=yes,resizable=no,status=no,height=" + MANAGE_BOOKMARK_WINDOW_HEIGHT + ",width=" + MANAGE_BOOKMARK_WINDOW_WIDTH + ",left=" + xOffset + ",top=" + yOffset;

			var sURL = "managebookmark.htm";

    			g_oManageBookmarkWin = window.open(sURL,"",sWinProps);
			if (g_oManageBookmarkWin)
			{
				window.attachEvent("onunload",CloseWindow);
				document.body.attachEvent("onfocus",StealWindowFocus);
				window.attachEvent("onfocus",StealWindowFocus);
			}
		}
		g_oManageBookmarkWin.focus();
	}
	catch(e)
	{
	}
}

//--------------------------------------------------------------------
// Function: CloseWindow
//
// Purpose: Closes the currently open window (either Manage Bookmark or
//		Add Bookmark)
//
// Parameters: None
//
// Returns: None
//--------------------------------------------------------------------
function CloseWindow()
{
	try
	{
		document.body.detachEvent("onfocus",StealWindowFocus);
		window.detachEvent("onfocus",StealWindowFocus);

		if (g_oAddBookmarkWin && !g_oAddBookmarkWin.closed)
			g_oAddBookmarkWin.close();
		else if (g_oManageBookmarkWin && !g_oManageBookmarkWin.closed)
			g_oManageBookmarkWin.close();
	}
	catch(e)
	{
	}
}

//--------------------------------------------------------------------
// Function: StealWindowFocus
//
// Purpose: Gives focus to the currently open dialog window when focus
//		is given to the viewer window.  This typically occurs
//		when the dialog window is minimized.
//
// Parameters: None
//
// Returns: None
//--------------------------------------------------------------------
function StealWindowFocus()
{
	try
	{
		if (g_oAddBookmarkWin && !g_oAddBookmarkWin.closed)
		{
			g_oAddBookmarkWin.focus();
		}
		else if (g_oManageBookmarkWin && !g_oManageBookmarkWin.closed)
		{
			g_oManageBookmarkWin.focus();
		}
	}
	catch(e)
	{
	}
}
