/****************************************************************************************** 
** 
** Function findAPI(win) 
** Inputs:        win - a Window Object 
** Return:        If an API object is found, it is returned, otherwise null is returned. 
** 
** Description: 
** This function looks for an object named API in the supported window hierarchy, 
** 
******************************************************************************************/ 
var _Debug=false;

function findEKAPI(win) 
{ 

   // Search the window hierarchy for an object named "API"   
   // Look in the current window (win) and recursively look in any child frames 

   if (_Debug) 
   { 
      alert("win is: "+win.location.href); 
   } 


   if (win.API != null) 
   { 
      if (_Debug) 
      { 
         alert("found api in this window"); 
      } 
      return win.API; 
   } 

   if (win.length > 0)  // does the window have frames? 
   { 
      if (_Debug) 
      { 
         alert("looking for api in windows frames"); 
      } 

      for (var i=0;i<win.length;i++) 
      { 

         if (_Debug) 
         { 
            alert("looking for api in frames["+i+"]"); 
         } 
         var theAPI = findEKAPI(win.frames[i]); 
         if (theAPI != null) 
         { 
            return theAPI; 
         } 
      } 
   } 

   if (_Debug) 
   { 
      alert("didn't find api in this window (or its children)"); 
   } 
   return null; 

} 


/****************************************************************************************** 
** 
** Function FindLMSAPI() 
** Inputs:        none 
** Return:        If an API object is found, it is returned, otherwise null is returned. 
** 
** Description: 
** This function looks for an object named API, first in the current window's hierarchy, 
**  and then, if necessary, in the current window's opener window hierarchy (if there is 
**  an opener window). 
******************************************************************************************/ 

function FindEKLMSAPI() 
{ 

   // start at the topmost window - findAPI will recurse down through 
   // all of the child frames 
   var theAPI = findEKAPI(this.top); 

   if (theAPI == null) 
   { 
      // the API wasn't found in the current window's hierarchy.  If the 
      // current window has an opener (was launched by another window), 
      // check the opener's window hierarchy. 
      if (_Debug) 
      { 
         alert("checking to see if this window has an opener"); 
         alert("window.opener typeof is> "+typeof(window.opener)); 
      } 

      if (typeof(this.opener) != "undefined") 
      { 
         if (_Debug) 
         { 
            alert("checking this windows opener"); 
         } 
         if (this.opener != null) 
         { 
            if (_Debug) 
            { 
               alert("this windows opener is NOT null - looking there"); 
            } 
            theAPI = findEKAPI(this.opener.top); 
         } 
         else 
         { 
            if (_Debug) 
            { 
               alert("this windows opener is null"); 
            } 
         } 
      } 
   } 

   return theAPI; 
}
