// Copyright  2002 Microsoft Corporation.  All rights reserved. 
var id_cc_Nd = 12;
var id_cc_Nl = 13;
var id_cc_No = 14;
var id_cc_Pc = 15;
var id_cc_Pd = 16;
var id_cc_Pe = 17;
var id_cc_Pf = 18;
var id_cc_Pi = 19;
var id_cc_Po = 20;
var id_cc_Ps = 21;
var id_cc_XX = 29;
var id_cc_Cn = 30;

function get_ccs( in_string ) {
	var ret = new Array();
	for( var i = 0; i < in_string.length; i++ ){
		var l = in_string.charCodeAt( i );
		var r = get_cc( l );
		ret[ret.length] = r;
	}
	return ret;
}

function get_cc( v ) {

if(((v>=0x0030)&&(v<=0x0039))||
((v>=0x0660)&&(v<=0x0669))||
((v>=0x06F0)&&(v<=0x06F9))||
((v>=0x0966)&&(v<=0x096F))||
((v>=0x09E6)&&(v<=0x09EF))||
((v>=0x0A66)&&(v<=0x0A6F))||
((v>=0x0AE6)&&(v<=0x0AEF))||
((v>=0x0B66)&&(v<=0x0B6F))||
((v>=0x0BE7)&&(v<=0x0BEF))||
((v>=0x0C66)&&(v<=0x0C6F))||
((v>=0x0CE6)&&(v<=0x0CEF))||
((v>=0x0D66)&&(v<=0x0D6F))||
((v>=0x0E50)&&(v<=0x0E59))||
((v>=0x0ED0)&&(v<=0x0ED9))||
((v>=0x0F20)&&(v<=0x0F29))||
((v>=0x1040)&&(v<=0x1049))||
((v>=0x1369)&&(v<=0x1371))||
((v>=0x17E0)&&(v<=0x17E9))||
((v>=0x1810)&&(v<=0x1819))||
((v>=0xFF10)&&(v<=0xFF19))||
((v>=0x1D7CE)&&(v<=0x1D7FF))
){ return id_cc_Nd; }

if(((v>=0x16EE)&&(v<=0x16F0))||
((v>=0x2160)&&(v<=0x2183))||
(v==0x3007)|| 
((v>=0x3021)&&(v<=0x3029))||
((v>=0x3038)&&(v<=0x303A))||
(v==0x1034A)
){ return id_cc_Nl; }

if(((v>=0x00B2)&&(v<=0x00B3))||
(v==0x00B9)|| 
((v>=0x00BC)&&(v<=0x00BE))||
((v>=0x09F4)&&(v<=0x09F9))||
((v>=0x0BF0)&&(v<=0x0BF2))||
((v>=0x0F2A)&&(v<=0x0F33))||
((v>=0x1372)&&(v<=0x137C))||
((v>=0x2070)&&(v<=0x2079))||
((v>=0x2080)&&(v<=0x2089))||
((v>=0x2153)&&(v<=0x215F))||
((v>=0x2460)&&(v<=0x249B))||
(v==0x24EA)|| 
((v>=0x2776)&&(v<=0x2793))||
((v>=0x3192)&&(v<=0x3195))||
((v>=0x3220)&&(v<=0x3229))||
((v>=0x3280)&&(v<=0x3289))||
((v>=0x10320)&&(v<=0x10323))
){ return id_cc_No; }

if((v==0x005F)|| 
((v>=0x203F)&&(v<=0x2040))||
(v==0x30FB)|| 
((v>=0xFE33)&&(v<=0xFE34))||
((v>=0xFE4D)&&(v<=0xFE4F))||
(v==0xFF3F)|| 
(v==0xFF65)
){ return id_cc_Pc; }

if((v==0x002D)|| 
(v==0x00AD)|| 
(v==0x058A)|| 
(v==0x1806)|| 
((v>=0x2010)&&(v<=0x2015))||
(v==0x301C)|| 
(v==0x3030)|| 
((v>=0xFE31)&&(v<=0xFE32))||
(v==0xFE58)|| 
(v==0xFE63)|| 
(v==0xFF0D)
){ return id_cc_Pd; }

if((v==0x0029)|| 
(v==0x005D)|| 
(v==0x007D)|| 
(v==0x0F3B)|| 
(v==0x0F3D)|| 
(v==0x169C)|| 
(v==0x2046)|| 
(v==0x207E)|| 
(v==0x208E)|| 
(v==0x232A)|| 
(v==0x3009)|| 
(v==0x300B)|| 
(v==0x300D)|| 
(v==0x300F)|| 
(v==0x3011)|| 
(v==0x3015)|| 
(v==0x3017)|| 
(v==0x3019)|| 
(v==0x301B)|| 
((v>=0x301E)&&(v<=0x301F))||
(v==0xFD3F)|| 
(v==0xFE36)|| 
(v==0xFE38)|| 
(v==0xFE3A)|| 
(v==0xFE3C)|| 
(v==0xFE3E)|| 
(v==0xFE40)|| 
(v==0xFE42)|| 
(v==0xFE44)|| 
(v==0xFE5A)|| 
(v==0xFE5C)|| 
(v==0xFE5E)|| 
(v==0xFF09)|| 
(v==0xFF3D)|| 
(v==0xFF5D)|| 
(v==0xFF63)
){ return id_cc_Pe; }

if((v==0x00BB)|| 
(v==0x2019)|| 
(v==0x201D)|| 
(v==0x203A)
){ return id_cc_Pf; }

if((v==0x00AB)|| 
(v==0x2018)|| 
((v>=0x201B)&&(v<=0x201C))||
(v==0x201F)|| 
(v==0x2039)
){ return id_cc_Pi; }

if(((v>=0x0021)&&(v<=0x0023))||
((v>=0x0025)&&(v<=0x0027))||
(v==0x002A)|| 
(v==0x002C)|| 
((v>=0x002E)&&(v<=0x002F))||
((v>=0x003A)&&(v<=0x003B))||
((v>=0x003F)&&(v<=0x0040))||
(v==0x005C)|| 
(v==0x00A1)|| 
(v==0x00B7)|| 
(v==0x00BF)|| 
(v==0x037E)|| 
(v==0x0387)|| 
((v>=0x055A)&&(v<=0x055F))||
(v==0x0589)|| 
(v==0x05BE)|| 
(v==0x05C0)|| 
(v==0x05C3)|| 
((v>=0x05F3)&&(v<=0x061F))||
((v>=0x066A)&&(v<=0x066D))||
(v==0x06D4)|| 
((v>=0x0700)&&(v<=0x070D))||
((v>=0x0964)&&(v<=0x0965))||
(v==0x0970)|| 
(v==0x0DF4)|| 
(v==0x0E4F)|| 
((v>=0x0E5A)&&(v<=0x0E5B))||
((v>=0x0F04)&&(v<=0x0F12))||
(v==0x0F85)|| 
((v>=0x104A)&&(v<=0x104F))||
(v==0x10FB)|| 
((v>=0x1361)&&(v<=0x1368))||
((v>=0x166D)&&(v<=0x166E))||
((v>=0x16EB)&&(v<=0x16ED))||
((v>=0x17D4)&&(v<=0x17DA))||
(v==0x17DC)|| 
((v>=0x1800)&&(v<=0x1805))||
((v>=0x1807)&&(v<=0x180A))||
((v>=0x2016)&&(v<=0x2017))||
((v>=0x2020)&&(v<=0x2027))||
((v>=0x2030)&&(v<=0x2038))||
((v>=0x203B)&&(v<=0x203E))||
((v>=0x2041)&&(v<=0x2043))||
((v>=0x2048)&&(v<=0x204D))||
((v>=0x3001)&&(v<=0x3003))||
(v==0xFE30)|| 
((v>=0xFE49)&&(v<=0xFE4C))||
((v>=0xFE50)&&(v<=0xFE57))||
((v>=0xFE5F)&&(v<=0xFE61))||
(v==0xFE68)|| 
((v>=0xFE6A)&&(v<=0xFE6B))||
((v>=0xFF01)&&(v<=0xFF03))||
((v>=0xFF05)&&(v<=0xFF07))||
(v==0xFF0A)|| 
(v==0xFF0C)|| 
((v>=0xFF0E)&&(v<=0xFF0F))||
((v>=0xFF1A)&&(v<=0xFF1B))||
((v>=0xFF1F)&&(v<=0xFF20))||
(v==0xFF3C)|| 
(v==0xFF61)|| 
(v==0xFF64)
){ return id_cc_Po; }

if((v==0x0028)|| 
(v==0x005B)|| 
(v==0x007B)|| 
(v==0x0F3A)|| 
(v==0x0F3C)|| 
(v==0x169B)|| 
(v==0x201A)|| 
(v==0x201E)|| 
(v==0x2045)|| 
(v==0x207D)|| 
(v==0x208D)|| 
(v==0x2329)|| 
(v==0x3008)|| 
(v==0x300A)|| 
(v==0x300C)|| 
(v==0x300E)|| 
(v==0x3010)|| 
(v==0x3014)|| 
(v==0x3016)|| 
(v==0x3018)|| 
(v==0x301A)|| 
(v==0x301D)|| 
(v==0xFD3E)|| 
(v==0xFE35)|| 
(v==0xFE37)|| 
(v==0xFE39)|| 
(v==0xFE3B)|| 
(v==0xFE3D)|| 
(v==0xFE3F)|| 
(v==0xFE41)|| 
(v==0xFE43)|| 
(v==0xFE59)|| 
(v==0xFE5B)|| 
(v==0xFE5D)|| 
(v==0xFF08)|| 
(v==0xFF3B)|| 
(v==0xFF5B)|| 
(v==0xFF62)
){ return id_cc_Ps; }

return id_cc_XX;

}