// Copyright  2002 Microsoft Corporation.  All rights reserved. 

var dicts_base_path = "viewer/search";
var dicts_file = "viewer/search/dicts.xml";	
var dicts_doc = null;

var dicts = new Array();
var dict_ranges = new Array();
var pattern_ranges = new Array();

var dicts_rfc_1766_lang = "";

function get_dictionary_scripts(){
	var r = new Array();
	if ( dicts_doc == null ) dicts_doc = xml_load( dicts_file );
	var n = dicts_doc.documentElement.selectSingleNode("./dict_location[@lang='" + dicts_rfc_1766_lang + "']/item");
	if ( !n ) return r;
	while( n ){
		var a = n.getAttribute("scid");
		if (a!="") {	
			var i = parseInt(a);
			if ((i>-1)&&(i<42))	r[r.length] = i;
		}
		n = n.nextSibling;
	}
	return r;
}

function hasDictionary( in_lang ){
	if ( dicts_doc == null ) return false;
	var n = dicts_doc.documentElement.selectSingleNode("./dict_location[@lang='" + in_lang + "']/item");
	if ( !n ) return false;
	return true;	
}

function getHlof( in_lang ){
	
	var iRet = 2;
	if ( hasDictionary( in_lang ) ) iRet = 0;
	var n = dicts_doc.documentElement.selectSingleNode("//map[@lang='" + in_lang + "']");
	if ( n ) {
		var sAtt = n.getAttribute("hlof");
		if ( sAtt ){
			if ( sAtt != "" ){
				try {
					var iVal = parseInt( sAtt );
					iRet = iVal;
				} catch(e) { }
			}
		}
	}
	return iRet;
}

function add_dict_rng( in_scid ){
	if ( dicts_doc == null ) dicts_doc = xml_load( dicts_file );
	if ( dicts_doc == null ) return null;
	var s_scid = in_scid.toString();
	var n = dicts_doc.documentElement.selectSingleNode("./dict_location[@lang='" + dicts_rfc_1766_lang + "']/item[@scid='" + s_scid + "']");
	if ( !n ) return null;
	for( var i = 0; i < dict_ranges.length; i++ ){		//do we already have the dic with this script
		var test_rng = dict_ranges[i];
		for( var j = 0; j < test_rng.scids.length; j++ ){	//multiple scids
			if( test_rng.scids[j] == s_scid )	return dict_ranges[i];
		}
	} 
	dict_ranges[dict_ranges.length] = new dict_ranges_obj();
	return dict_ranges[dict_ranges.length-1];
}

function dict_ranges_obj(){
	this.doms = new Array();
	this.urls = new Array();
	this.scids = new Array()
	this.path = "";
	this.basepath = dicts_base_path;
	this.set_dict_range_path = function( xml_doc ){
		if ( xml_doc != null ){
			var n = xml_doc.documentElement.selectSingleNode("./dict_location[@lang='" + dicts_rfc_1766_lang + "']");
			if ( !n ) return;
			var elm = n;
			var out_path = elm.getAttribute("term_relpath");
			this.path = this.basepath + "/" + out_path;
			this.scids = new Array();
			for( var i = 0; i < elm.childNodes.length; i++ ){
				this.scids[this.scids.length] = elm.childNodes[i].getAttribute('scid');
			}
		}
	}
	this.set_dict_range_path( dicts_doc );
	this.basepath  = getbasepath( this.path );
	this.dictranges = xml_load( this.path );
	this.test_word_node = function( in_text ){

		var url = this.lookup_range_url( in_text );
		if ( url == "" ) return null;
		if ( this.basepath != "" ) url = this.basepath + "\\" + url;
		var ind = this.load_range_url( url );
		if(( in_text.indexOf("\\") > -1 )||( in_text.indexOf("'") > -1 )||( in_text.indexOf("\"") > -1 )||( in_text.indexOf("*") > -1 )){
			for( var i = 0; i < this.doms[ind].documentElement.childNodes.length; i++ ){
				var node = this.doms[ind].documentElement.childNodes[i];
				var comp = vbCompareString( node.text, in_text, true );
				if ( comp == 0 ) return node;
			}
			return null;
		} else {
			var node = this.doms[ind].documentElement.selectSingleNode( "./e[text()='"+in_text+"']" );
			if ( node != null ) return node;
			return null;
		}

		
	}

	this.lookup_range_url = function( in_text ){
		var elms = this.dictranges.documentElement.selectNodes( "./rng" );
		for( var i = 0; i < elms.length; i++ ){
			var att = elms[i].getAttribute("v");
			var ses = att.split(" - ");
			var cmp_l = vbCompareString( in_text, ses[0], true );
			var cmp_r = vbCompareString( in_text, ses[1], true );
			if(( cmp_l > -1 ) && ( cmp_r < 1 ))	return elms[i].getAttribute("s");
		}
		return "";
	}

	this.load_range_url = function( url ){
		for( var i = 0; i < this.doms.length; i++ ){
			if ( this.doms[i].url == url ) return i;
		}
		this.doms[this.doms.length] = xml_load( url );
		this.urls[this.urls.length] = url;
		return this.doms.length-1;
	}
}

function add_pat_rng( in_scid ){
	if ( dicts_doc == null ) dicts_doc = xml_load( dicts_file );
	if ( dicts_doc == null ) return null;
	var s_scid = in_scid.toString();
	var n = dicts_doc.documentElement.selectSingleNode("./dict_location[@lang='" + dicts_rfc_1766_lang + "']/item[@scid='" + s_scid + "']");
	if ( !n ) return null;
	for( var i = 0; i < pattern_ranges.length; i++ ){
		var test_rng = pattern_ranges[i];
		for( var j = 0; j < test_rng.scids.length; j++ ){	//multiple scids
			if( test_rng.scids[j] == s_scid )	return pattern_ranges[i];
		}
	}
	pattern_ranges[pattern_ranges.length] = new pattern_ranges_obj();
	return pattern_ranges[pattern_ranges.length-1];
}

function pattern_ranges_obj(){
	this.doms = new Array();
	this.urls = new Array();
	this.scids = new Array();
	this.path = "";
	this.basepath = dicts_base_path;
	this.set_pattern_range_path = function( xml_doc ){
		if ( xml_doc != null ){
			var n = xml_doc.documentElement.selectSingleNode("./dict_location[@lang='" + dicts_rfc_1766_lang + "']");
			if ( !n ) return;
			var elm = n;
			var out_path = elm.getAttribute("pattern_relpath");
			this.path = this.basepath + "/" + out_path;
			this.scids = new Array();
			for( var i = 0; i < elm.childNodes.length; i++ ){
				this.scids[this.scids.length] = elm.childNodes[i].getAttribute('scid');
			}
		}
	}
	this.set_pattern_range_path( dicts_doc );
	this.basepath  = getbasepath( this.path );
	this.patternranges = xml_load( this.path );
	this.lkw = function(){
		var lkw = this.patternranges.documentElement.getAttribute("lkw");
		if ( lkw == "" ) lkw = "50";
		return lkw.toString();
	}

	this.is_end_pattern = function( e ){
		var ends = this.patternranges.documentElement.getAttribute("ends");
		if ( ends == "" ) return false;
		if ( ends.indexOf(e) > -1 ) return true;
		return false;
	}

	this.is_start_pattern = function( e ){
		var starts = this.patternranges.documentElement.getAttribute("starts");
		if ( starts == "" ) return false;
		if ( starts.indexOf(e) > -1 ) return true;
		return false;
	}
	this.get_pattern_node = function( in_s ){
		var url = this.lookup_range_url( in_s );
		if ( url == "" ) return null;
		if ( this.basepath != "" ) url = this.basepath + "/" + url;
		var ind = this.load_range_url( url );
		var s_id = "id_" + in_s;
		var node = this.doms[ind].documentElement.selectSingleNode( "./p[@id='"+s_id+"']" );
		if ( node != null ) return node;
		return null;
	}
	this.lookup_range_url = function( in_s ) {
		var elms = this.patternranges.documentElement.selectNodes( "./rng" );
		for( var i = 0; i < elms.length; i++ ) {
			var att = elms[i].getAttribute("v");
			var ses = att.split(" - ");
			var cmp_l = vbCompareString( in_s, ses[0], true );
			var cmp_r = vbCompareString( in_s, ses[1], true );
			if(( cmp_l > -1 ) && ( cmp_r < 1 )) return elms[i].getAttribute("s");
		}
		return "";
	}
	this.load_range_url = function( url ){
		for( var i = 0; i < this.doms.length; i++ ){
			if ( this.doms[i].url == url ) return i;
		}
		this.doms[this.doms.length] = xml_load( url );
		this.urls[this.doms.length] = url;
		return this.doms.length-1;
	}
}

function match_dict_patterns_rev( in_fwo, dr, pr ){
	if (( dr == null ) | ( pr == null )) return in_fwo;
	in_fwo.offsets.length = 0;
	var i = 0;
	var lkword = pr.lkw();

	for( i = in_fwo.str.length-1; i > -1; i-- ) {
		var b_dict = false;
		var fl = 1;	
		if ( i + 1 < lkword ) lkword = i + 1;
		var cw = in_fwo.str.substr( ( i + 1 )- ( lkword ), lkword );
		if ( pr.is_end_pattern( cw.substr(cw.length-1) )){
			while( cw.Length > 1 ){
				while(( !pr.is_start_pattern( cw.substr( 0,1 ))) && ( cw.length > 1 )) cw = cw.substr( 1 );
				if ( cw.length <= 1 ) break;
				var node  = pr.get_pattern_node( cw.substr( 0,1 ) );
				if ( node == null )	break;
				var ends = node.getAttribute("e");
				if (( ends != null ) && ( ends != "" )){
					if( ends.indexOf( cw[cw.length-1] ) > -1  ){
						if ( dr.test_word_node( cw ) != null ){
							i-= cw.length-1;
							fl = cw.length;
							b_dict = true;
							break;
						}
					}
				}
				cw = cw.substr( 1 );	
			}
		}
		in_fwo.add_word_offest_begin( i, fl, b_dict );
	}
	return in_fwo;
}

function match_dict_patterns( in_fwo, dr, pr ){		
	if (( dr == null ) | ( pr == null )) return in_fwo;
	in_fwo.offsets.length = 0;
	var i = 0;
	var lkword = pr.lkw();
	for( i = 0; i < in_fwo.str.length; i++ ) {
		var b_dict = false;
		if ( (in_fwo.str.length - i ) < lkword ) lkword = in_fwo.str.length - i;
		var cw = in_fwo.str.substr( i, lkword );
		if ( pr.is_start_pattern( cw.charAt(0) ) == false ) {
			if ( in_fwo.offsets.length > 0 ){
				var off_obj = in_fwo.offsets[in_fwo.offsets.length-1];
				if (( off_obj.start + off_obj.length ) < i )	continue;	
			}
			in_fwo.add_word_offest( i, 1, b_dict );
			continue;
		}
		var node  = pr.get_pattern_node( cw.charAt(0) );
		if ( node == null ){
			in_fwo.add_word_offest( i, 1, b_dict );
			continue;
		}

		var ends = node.getAttribute("e");

		if (( ends != null ) &&  ( cw.length - 1 > 0 ) && ( ends != "" )){
			var j = cw.length - 1;
			var b_offset = false;
			while(( j > 0 ) && ( b_offset == false )){
				//if ( pr.is_end_pattern( cw.charAt(cw.length-1) )) {
				if ( pr.is_end_pattern( cw.charAt(j) )) {
					if (( ends.charCodeAt(0) == cw.charCodeAt(j) ) || ( ends.indexOf( cw.charAt(j)+" ") != -1 ) || ( ends.indexOf(" "+cw.charAt(j)) != -1 )){
						var tw = cw.substr(0,j+1);
						if ( dr.test_word_node( tw ) != null ) {
							b_dict = true;
							in_fwo.add_word_offest( i, tw.length, b_dict );
							i += (tw.length - 1);
							b_offset = true;
						}
					}
				}
				j--;
			}
			if ( b_offset == true )	continue;
			else in_fwo.add_word_offest( i, 1, b_dict );
		} else {
			b_dict = true;
			in_fwo.add_word_offest( i, 1, b_dict );
		}
	}
	return in_fwo;
}

function offset_obj( in_start, in_length, in_dict ) {
	this.start = in_start;
	this.length = in_length;
	this.b_dict = in_dict;
}

function fwo_obj( in_string, in_scid ) {
	this.str = in_string;
	this.scid = in_scid;
	this.offsets = new Array();
	this.start = 0;
	this.length = in_string.length;
	this.add_word_offest = function( in_start, in_length, in_dict ) {
		this.offsets[this.offsets.length] = new offset_obj( in_start, in_length, in_dict );
	}

	this.add_word_offest_begin =  function( in_start, in_length, in_dict ){
		if ( this.offsets.length == 0 )	this.offsets[this.offsets.length] = new offset_obj( in_start, in_length, in_dict );
		else {
			var a = new Array( new offset_obj( in_start, in_length, in_dict ) );
			this.offsets = a.concat( this.offsets );
		}
	}
}