// Copyright  2002 Microsoft Corporation.  All rights reserved. 

var id_scr_LATIN = 0;
var id_scr_GREEK = 1;
var id_scr_CYRILLIC = 2;
var id_scr_ARMENIAN = 3;
var id_scr_HEBREW = 4;
var id_scr_ARABIC = 5;
var id_scr_SYRIAC = 6;
var id_scr_THAANA = 7;
var id_scr_DEVANAGARI = 8;
var id_scr_BENGALI = 9;
var id_scr_GURMUKHI = 11;
var id_scr_GUJARATI = 12;
var id_scr_ORIYA = 13;
var id_scr_TAMIL = 14;
var id_scr_TELUGU = 15;
var id_scr_KANNADA = 16;
var id_scr_MALAYALAM = 17;
var id_scr_SINHALA = 18;
var id_scr_THAI = 19;
var id_scr_LAO = 20;
var id_scr_TIBETAN = 21;
var id_scr_MYANMAR = 22;
var id_scr_GEORGIAN = 23;
var id_scr_HANGUL = 24;
var id_scr_ETHIOPIC = 25;
var id_scr_CHEROKEE = 26;
var id_scr_CANADIAN_ABORIGINAL = 27;
var id_scr_OGHAM = 28;
var id_scr_RUNIC = 29;
var id_scr_KHMER = 30;
var id_scr_MONGOLIAN = 31;
var id_scr_HIRAGANA = 32;
var id_scr_KATAKANA = 33;
var id_scr_BOPOMOFO = 34;
var id_scr_HAN = 35;
var id_scr_YI = 36;
var id_scr_OLD_ITALIC = 37;
var id_scr_GOTHIC = 38;
var id_scr_DESERET = 39;
var id_scr_INHERITED = 40;
var id_scr_COMMON = 41;

function get_scrs( in_string ) {
	var ret = new Array();
	for( var i = 0; i < in_string.length; i++ ){
		var l = in_string.charCodeAt( i );
		var r = get_scr( l );
		ret[ret.length] = r;
	}
	return ret;
}

//MV CHANGE unused function?
function check_for_bounds( in_scid ){
	if( 
		(in_scid==id_scr_THAI)||
		(in_scid==id_scr_LAO)||
		(in_scid==id_scr_MYANMAR)||
		(in_scid==id_scr_HANGUL)||
		(in_scid==id_scr_KHMER)||
		(in_scid==id_scr_HIRAGANA)||
		(in_scid==id_scr_KATAKANA)||
		(in_scid==id_scr_BOPOMOFO)||
		(in_scid==id_scr_HAN)||
		(in_scid==id_scr_YI)){
		return false;
	}
	return true;
}

function get_scr( v ) {

if(((v>=0x0041)&&(v<=0x005A))||
((v>=0x0061)&&(v<=0x007A))||
(v==0x00AA)||
(v==0x00BA)||
((v>=0x00C0)&&(v<=0x00D6))||
((v>=0x00D8)&&(v<=0x00F6))||
((v>=0x00F8)&&(v<=0x01BA))||
(v==0x01BB)||
((v>=0x01BC)&&(v<=0x01BF))||
((v>=0x01C0)&&(v<=0x01C3))||
((v>=0x01C4)&&(v<=0x021F))||
((v>=0x0222)&&(v<=0x0233))||
((v>=0x0250)&&(v<=0x02AD))||
((v>=0x02B0)&&(v<=0x02B8))||
((v>=0x02E0)&&(v<=0x02E4))||
((v>=0x1E00)&&(v<=0x1E9B))||
((v>=0x1EA0)&&(v<=0x1EF9))||
(v==0x207F)||
((v>=0x212A)&&(v<=0x212B))||
((v>=0xFB00)&&(v<=0xFB06))||
((v>=0xFF21)&&(v<=0xFF3A))||
((v>=0xFF41)&&(v<=0xFF5A))
){ return id_scr_LATIN; }

if((v==0x00B5)||
(v==0x037A)||
(v==0x0386)||
((v>=0x0388)&&(v<=0x038A))||
(v==0x038C)||
((v>=0x038E)&&(v<=0x03A1))||
((v>=0x03A3)&&(v<=0x03CE))||
((v>=0x03D0)&&(v<=0x03D7))||
((v>=0x03DA)&&(v<=0x03F5))||
((v>=0x1F00)&&(v<=0x1F15))||
((v>=0x1F18)&&(v<=0x1F1D))||
((v>=0x1F20)&&(v<=0x1F45))||
((v>=0x1F48)&&(v<=0x1F4D))||
((v>=0x1F50)&&(v<=0x1F57))||
(v==0x1F59)||
(v==0x1F5B)||
(v==0x1F5D)||
((v>=0x1F5F)&&(v<=0x1F7D))||
((v>=0x1F80)&&(v<=0x1FB4))||
((v>=0x1FB6)&&(v<=0x1FBC))||
(v==0x1FBE)||
((v>=0x1FC2)&&(v<=0x1FC4))||
((v>=0x1FC6)&&(v<=0x1FCC))||
((v>=0x1FD0)&&(v<=0x1FD3))||
((v>=0x1FD6)&&(v<=0x1FDB))||
((v>=0x1FE0)&&(v<=0x1FEC))||
((v>=0x1FF2)&&(v<=0x1FF4))||
((v>=0x1FF6)&&(v<=0x1FFC))||
(v==0x2126)
){ return id_scr_GREEK; }

if(((v>=0x0400)&&(v<=0x0481))||
((v>=0x0483)&&(v<=0x0486))||
((v>=0x048C)&&(v<=0x04C4))||
((v>=0x04C7)&&(v<=0x04C8))||
((v>=0x04CB)&&(v<=0x04CC))||
((v>=0x04D0)&&(v<=0x04F5))||
((v>=0x04F8)&&(v<=0x04F9))
){ return id_scr_CYRILLIC; }

if(((v>=0x0531)&&(v<=0x0556))||
(v==0x0559)||
((v>=0x0561)&&(v<=0x0587))||
((v>=0xFB13)&&(v<=0xFB17))
){ return id_scr_ARMENIAN; }

if(((v>=0x05D0)&&(v<=0x05EA))||
((v>=0x05F0)&&(v<=0x05F2))||
(v==0xFB1D)||
((v>=0xFB1F)&&(v<=0xFB28))||
((v>=0xFB2A)&&(v<=0xFB36))||
((v>=0xFB38)&&(v<=0xFB3C))||
(v==0xFB3E)||
((v>=0xFB40)&&(v<=0xFB41))||
((v>=0xFB43)&&(v<=0xFB44))||
((v>=0xFB46)&&(v<=0xFB4F))
){ return id_scr_HEBREW; }

if(((v>=0x0621)&&(v<=0x063A))||
((v>=0x0641)&&(v<=0x064A))||
((v>=0x0671)&&(v<=0x06D3))||
(v==0x06D5)||
((v>=0x06E5)&&(v<=0x06E6))||
((v>=0x06FA)&&(v<=0x06FC))||
((v>=0xFB50)&&(v<=0xFBB1))||
((v>=0xFBD3)&&(v<=0xFD3D))||
((v>=0xFD50)&&(v<=0xFD8F))||
((v>=0xFD92)&&(v<=0xFDC7))||
((v>=0xFDF0)&&(v<=0xFDFB))||
((v>=0xFE70)&&(v<=0xFE72))||
(v==0xFE74)||
((v>=0xFE76)&&(v<=0xFEFC))
){ return id_scr_ARABIC; }

if((v==0x0710)||
(v==0x0711)||
((v>=0x0712)&&(v<=0x072C))||
((v>=0x0730)&&(v<=0x074A))
){ return id_scr_SYRIAC; }

if(((v>=0x0780)&&(v<=0x07A5))||
((v>=0x07A6)&&(v<=0x07B0))
){ return id_scr_THAANA; }

if(((v>=0x0901)&&(v<=0x0902))||
(v==0x0903)||
((v>=0x0905)&&(v<=0x0939))||
(v==0x093C)||
(v==0x093D)||
((v>=0x093E)&&(v<=0x0940))||
((v>=0x0941)&&(v<=0x0948))||
((v>=0x0949)&&(v<=0x094C))||
(v==0x094D)||
(v==0x0950)||
((v>=0x0951)&&(v<=0x0954))||
((v>=0x0958)&&(v<=0x0961))||
((v>=0x0962)&&(v<=0x0963))||
((v>=0x0966)&&(v<=0x096F))
){ return id_scr_DEVANAGARI; }

if((v==0x0981)||
((v>=0x0985)&&(v<=0x098C))||
((v>=0x098F)&&(v<=0x0990))||
((v>=0x0993)&&(v<=0x09A8))||
((v>=0x09AA)&&(v<=0x09B0))||
(v==0x09B2)||
((v>=0x09B6)&&(v<=0x09B9))||
(v==0x09BC)||
((v>=0x09BE)&&(v<=0x09C0))||
((v>=0x09C1)&&(v<=0x09C4))||
((v>=0x09C7)&&(v<=0x09C8))||
((v>=0x09CB)&&(v<=0x09CC))||
(v==0x09CD)||
(v==0x09D7)||
((v>=0x09DC)&&(v<=0x09DD))||
((v>=0x09DF)&&(v<=0x09E1))||
((v>=0x09E2)&&(v<=0x09E3))||
((v>=0x09E6)&&(v<=0x09EF))||
((v>=0x09F0)&&(v<=0x09F1))
){ return id_scr_BENGALI; }

if((v==0x0A02)||
((v>=0x0A05)&&(v<=0x0A0A))||
((v>=0x0A0F)&&(v<=0x0A10))||
((v>=0x0A13)&&(v<=0x0A28))||
((v>=0x0A2A)&&(v<=0x0A30))||
((v>=0x0A32)&&(v<=0x0A33))||
((v>=0x0A35)&&(v<=0x0A36))||
((v>=0x0A38)&&(v<=0x0A39))||
(v==0x0A3C)||
((v>=0x0A3E)&&(v<=0x0A40))||
((v>=0x0A41)&&(v<=0x0A42))||
((v>=0x0A47)&&(v<=0x0A48))||
((v>=0x0A4B)&&(v<=0x0A4D))||
((v>=0x0A59)&&(v<=0x0A5C))||
(v==0x0A5E)||
((v>=0x0A66)&&(v<=0x0A6F))||
((v>=0x0A70)&&(v<=0x0A71))||
((v>=0x0A72)&&(v<=0x0A74))
){ return id_scr_GURMUKHI; }

if(((v>=0x0A81)&&(v<=0x0A82))||
(v==0x0A83)||
((v>=0x0A85)&&(v<=0x0A8B))||
(v==0x0A8D)||
((v>=0x0A8F)&&(v<=0x0A91))||
((v>=0x0A93)&&(v<=0x0AA8))||
((v>=0x0AAA)&&(v<=0x0AB0))||
((v>=0x0AB2)&&(v<=0x0AB3))||
((v>=0x0AB5)&&(v<=0x0AB9))||
(v==0x0ABC)||
(v==0x0ABD)||
((v>=0x0ABE)&&(v<=0x0AC0))||
((v>=0x0AC1)&&(v<=0x0AC5))||
((v>=0x0AC7)&&(v<=0x0AC8))||
(v==0x0AC9)||
((v>=0x0ACB)&&(v<=0x0ACC))||
(v==0x0ACD)||
(v==0x0AD0)||
(v==0x0AE0)||
((v>=0x0AE6)&&(v<=0x0AEF))
){ return id_scr_GUJARATI; }

if((v==0x0B01)||
((v>=0x0B02)&&(v<=0x0B03))||
((v>=0x0B05)&&(v<=0x0B0C))||
((v>=0x0B0F)&&(v<=0x0B10))||
((v>=0x0B13)&&(v<=0x0B28))||
((v>=0x0B2A)&&(v<=0x0B30))||
((v>=0x0B32)&&(v<=0x0B33))||
((v>=0x0B36)&&(v<=0x0B39))||
(v==0x0B3C)||
(v==0x0B3D)||
(v==0x0B3E)||
(v==0x0B3F)||
(v==0x0B40)||
((v>=0x0B41)&&(v<=0x0B43))||
((v>=0x0B47)&&(v<=0x0B48))||
((v>=0x0B4B)&&(v<=0x0B4C))||
(v==0x0B4D)||
(v==0x0B56)||
(v==0x0B57)||
((v>=0x0B5C)&&(v<=0x0B5D))||
((v>=0x0B5F)&&(v<=0x0B61))||
((v>=0x0B66)&&(v<=0x0B6F))
){ return id_scr_ORIYA; }

if((v==0x0B82)||
(v==0x0B83)||
((v>=0x0B85)&&(v<=0x0B8A))||
((v>=0x0B8E)&&(v<=0x0B90))||
((v>=0x0B92)&&(v<=0x0B95))||
((v>=0x0B99)&&(v<=0x0B9A))||
(v==0x0B9C)||
((v>=0x0B9E)&&(v<=0x0B9F))||
((v>=0x0BA3)&&(v<=0x0BA4))||
((v>=0x0BA8)&&(v<=0x0BAA))||
((v>=0x0BAE)&&(v<=0x0BB5))||
((v>=0x0BB7)&&(v<=0x0BB9))||
((v>=0x0BBE)&&(v<=0x0BBF))||
(v==0x0BC0)||
((v>=0x0BC1)&&(v<=0x0BC2))||
((v>=0x0BC6)&&(v<=0x0BC8))||
((v>=0x0BCA)&&(v<=0x0BCC))||
(v==0x0BCD)||
(v==0x0BD7)||
((v>=0x0BE7)&&(v<=0x0BEF))||
((v>=0x0BF0)&&(v<=0x0BF2))
){ return id_scr_TAMIL; }

if(((v>=0x0C01)&&(v<=0x0C03))||
((v>=0x0C05)&&(v<=0x0C0C))||
((v>=0x0C0E)&&(v<=0x0C10))||
((v>=0x0C12)&&(v<=0x0C28))||
((v>=0x0C2A)&&(v<=0x0C33))||
((v>=0x0C35)&&(v<=0x0C39))||
((v>=0x0C3E)&&(v<=0x0C40))||
((v>=0x0C41)&&(v<=0x0C44))||
((v>=0x0C46)&&(v<=0x0C48))||
((v>=0x0C4A)&&(v<=0x0C4D))||
((v>=0x0C55)&&(v<=0x0C56))||
((v>=0x0C60)&&(v<=0x0C61))||
((v>=0x0C66)&&(v<=0x0C6F))
){ return id_scr_TELUGU; }

if(((v>=0x0C82)&&(v<=0x0C83))||
((v>=0x0C85)&&(v<=0x0C8C))||
((v>=0x0C8E)&&(v<=0x0C90))||
((v>=0x0C92)&&(v<=0x0CA8))||
((v>=0x0CAA)&&(v<=0x0CB3))||
((v>=0x0CB5)&&(v<=0x0CB9))||
(v==0x0CBE)||
(v==0x0CBF)||
((v>=0x0CC0)&&(v<=0x0CC4))||
(v==0x0CC6)||
((v>=0x0CC7)&&(v<=0x0CC8))||
((v>=0x0CCA)&&(v<=0x0CCB))||
((v>=0x0CCC)&&(v<=0x0CCD))||
((v>=0x0CD5)&&(v<=0x0CD6))||
(v==0x0CDE)||
((v>=0x0CE0)&&(v<=0x0CE1))||
((v>=0x0CE6)&&(v<=0x0CEF))
){ return id_scr_KANNADA; }

if(((v>=0x0D02)&&(v<=0x0D03))||
((v>=0x0D05)&&(v<=0x0D0C))||
((v>=0x0D0E)&&(v<=0x0D10))||
((v>=0x0D12)&&(v<=0x0D28))||
((v>=0x0D2A)&&(v<=0x0D39))||
((v>=0x0D3E)&&(v<=0x0D40))||
((v>=0x0D41)&&(v<=0x0D43))||
((v>=0x0D46)&&(v<=0x0D48))||
((v>=0x0D4A)&&(v<=0x0D4C))||
(v==0x0D4D)||
(v==0x0D57)||
((v>=0x0D60)&&(v<=0x0D61))||
((v>=0x0D66)&&(v<=0x0D6F))
){ return id_scr_MALAYALAM; }

if(((v>=0x0D82)&&(v<=0x0D83))||
((v>=0x0D85)&&(v<=0x0D96))||
((v>=0x0D9A)&&(v<=0x0DB1))||
((v>=0x0DB3)&&(v<=0x0DBB))||
(v==0x0DBD)||
((v>=0x0DC0)&&(v<=0x0DC6))||
(v==0x0DCA)||
((v>=0x0DCF)&&(v<=0x0DD1))||
((v>=0x0DD2)&&(v<=0x0DD4))||
(v==0x0DD6)||
((v>=0x0DD8)&&(v<=0x0DDF))||
((v>=0x0DF2)&&(v<=0x0DF3))
){ return id_scr_SINHALA; }

if(((v>=0x0E01)&&(v<=0x0E30))||
(v==0x0E31)||
((v>=0x0E32)&&(v<=0x0E33))||
((v>=0x0E34)&&(v<=0x0E3A))||
((v>=0x0E40)&&(v<=0x0E45))||
(v==0x0E46)||
((v>=0x0E47)&&(v<=0x0E4E))||
((v>=0x0E50)&&(v<=0x0E59))
){ return id_scr_THAI; }

if(((v>=0x0E81)&&(v<=0x0E82))||
(v==0x0E84)||
((v>=0x0E87)&&(v<=0x0E88))||
(v==0x0E8A)||
(v==0x0E8D)||
((v>=0x0E94)&&(v<=0x0E97))||
((v>=0x0E99)&&(v<=0x0E9F))||
((v>=0x0EA1)&&(v<=0x0EA3))||
(v==0x0EA5)||
(v==0x0EA7)||
((v>=0x0EAA)&&(v<=0x0EAB))||
((v>=0x0EAD)&&(v<=0x0EB0))||
(v==0x0EB1)||
((v>=0x0EB2)&&(v<=0x0EB3))||
((v>=0x0EB4)&&(v<=0x0EB9))||
((v>=0x0EBB)&&(v<=0x0EBC))||
(v==0x0EBD)||
((v>=0x0EC0)&&(v<=0x0EC4))||
(v==0x0EC6)||
((v>=0x0EC8)&&(v<=0x0ECD))||
((v>=0x0ED0)&&(v<=0x0ED9))||
((v>=0x0EDC)&&(v<=0x0EDD))
){ return id_scr_LAO; }

if((v==0x0F00)||
((v>=0x0F18)&&(v<=0x0F19))||
((v>=0x0F20)&&(v<=0x0F29))||
((v>=0x0F2A)&&(v<=0x0F33))||
(v==0x0F35)||
(v==0x0F37)||
(v==0x0F39)||
((v>=0x0F40)&&(v<=0x0F47))||
((v>=0x0F49)&&(v<=0x0F6A))||
((v>=0x0F71)&&(v<=0x0F7E))||
(v==0x0F7F)||
((v>=0x0F80)&&(v<=0x0F84))||
((v>=0x0F86)&&(v<=0x0F87))||
((v>=0x0F88)&&(v<=0x0F8B))||
((v>=0x0F90)&&(v<=0x0F97))||
((v>=0x0F99)&&(v<=0x0FBC))||
(v==0x0FC6)
){ return id_scr_TIBETAN; }

if(((v>=0x1000)&&(v<=0x1021))||
((v>=0x1023)&&(v<=0x1027))||
((v>=0x1029)&&(v<=0x102A))||
(v==0x102C)||
((v>=0x102D)&&(v<=0x1030))||
(v==0x1031)||
(v==0x1032)||
((v>=0x1036)&&(v<=0x1037))||
(v==0x1038)||
(v==0x1039)||
((v>=0x1040)&&(v<=0x1049))||
((v>=0x1050)&&(v<=0x1055))||
((v>=0x1056)&&(v<=0x1057))||
((v>=0x1058)&&(v<=0x1059))
){ return id_scr_MYANMAR; }

if(((v>=0x10A0)&&(v<=0x10C5))||
((v>=0x10D0)&&(v<=0x10F6))
){ return id_scr_GEORGIAN; }

if(((v>=0x1100)&&(v<=0x1159))||
((v>=0x115F)&&(v<=0x11A2))||
((v>=0x11A8)&&(v<=0x11F9))||
((v>=0x3131)&&(v<=0x318E))||
((v>=0xAC00)&&(v<=0xD7A3))||
((v>=0xFFA0)&&(v<=0xFFBE))||
((v>=0xFFC2)&&(v<=0xFFC7))||
((v>=0xFFCA)&&(v<=0xFFCF))||
((v>=0xFFD2)&&(v<=0xFFD7))||
((v>=0xFFDA)&&(v<=0xFFDC))
){ return id_scr_HANGUL; }

if(((v>=0x1200)&&(v<=0x1206))||
((v>=0x1208)&&(v<=0x1246))||
(v==0x1248)||
((v>=0x124A)&&(v<=0x124D))||
((v>=0x1250)&&(v<=0x1256))||
(v==0x1258)||
((v>=0x125A)&&(v<=0x125D))||
((v>=0x1260)&&(v<=0x1286))||
(v==0x1288)||
((v>=0x128A)&&(v<=0x128D))||
((v>=0x1290)&&(v<=0x12AE))||
(v==0x12B0)||
((v>=0x12B2)&&(v<=0x12B5))||
((v>=0x12B8)&&(v<=0x12BE))||
(v==0x12C0)||
((v>=0x12C2)&&(v<=0x12C5))||
((v>=0x12C8)&&(v<=0x12CE))||
((v>=0x12D0)&&(v<=0x12D6))||
((v>=0x12D8)&&(v<=0x12EE))||
((v>=0x12F0)&&(v<=0x130E))||
(v==0x1310)||
((v>=0x1312)&&(v<=0x1315))||
((v>=0x1318)&&(v<=0x131E))||
((v>=0x1320)&&(v<=0x1346))||
((v>=0x1348)&&(v<=0x135A))||
((v>=0x1369)&&(v<=0x1371))||
((v>=0x1372)&&(v<=0x137C))
){ return id_scr_ETHIOPIC; }

if((v>=0x13A0)&&(v<=0x13F4))
{ return id_scr_CHEROKEE; }

if(((v>=0x1401)&&(v<=0x166C))||
((v>=0x166F)&&(v<=0x1676))
){ return id_scr_CANADIAN_ABORIGINAL; }

if((v>=0x1681)&&(v<=0x169A))
{ return id_scr_OGHAM; }

if(((v>=0x16A0)&&(v<=0x16EA))||
((v>=0x16EE)&&(v<=0x16F0))
){ return id_scr_RUNIC; }

if(((v>=0x1780)&&(v<=0x17B3))||
((v>=0x17B4)&&(v<=0x17B6))||
((v>=0x17B7)&&(v<=0x17BD))||
((v>=0x17BE)&&(v<=0x17C5))||
(v==0x17C6)||
((v>=0x17C7)&&(v<=0x17C8))||
((v>=0x17C9)&&(v<=0x17D3))||
((v>=0x17E0)&&(v<=0x17E9))
){ return id_scr_KHMER; }

if(((v>=0x1810)&&(v<=0x1819))||
((v>=0x1820)&&(v<=0x1842))||
(v==0x1843)||
((v>=0x1844)&&(v<=0x1877))||
((v>=0x1880)&&(v<=0x18A8))||
(v==0x18A9)
){ return id_scr_MONGOLIAN; }

if(((v>=0x3041)&&(v<=0x3094))||
((v>=0x309D)&&(v<=0x309E))
){ return id_scr_HIRAGANA; }

if(((v>=0x30A1)&&(v<=0x30FA))||
((v>=0x30FD)&&(v<=0x30FE))||
((v>=0xFF66)&&(v<=0xFF6F))||
((v>=0xFF71)&&(v<=0xFF9D))
){ return id_scr_KATAKANA; }

if(((v>=0x3105)&&(v<=0x312C))||
((v>=0x31A0)&&(v<=0x31B7))
){ return id_scr_BOPOMOFO; }

if(((v>=0x2E80)&&(v<=0x2E99))||
((v>=0x2E9B)&&(v<=0x2EF3))||
((v>=0x2F00)&&(v<=0x2FD5))||
(v==0x3005)||
(v==0x3007)||
((v>=0x3021)&&(v<=0x3029))||
((v>=0x3038)&&(v<=0x303A))||
((v>=0x3400)&&(v<=0x4DB5))||
((v>=0x4E00)&&(v<=0x9FA5))||
((v>=0xF900)&&(v<=0xFA2D))||
((v>=0x20000)&&(v<=0x2A6D6))||
((v>=0x2F800)&&(v<=0x2FA1D))
){ return id_scr_HAN; }

if(((v>=0xA000)&&(v<=0xA48C))||
((v>=0xA490)&&(v<=0xA4A1))||
((v>=0xA4A4)&&(v<=0xA4B3))||
((v>=0xA4B5)&&(v<=0xA4C0))||
((v>=0xA4C2)&&(v<=0xA4C4))||
(v==0xA4C6)
){ return id_scr_YI; }

if((v>=0x10300)&&(v<=0x1031E))
{ return id_scr_OLD_ITALIC; }

if(((v>=0x10330)&&(v<=0x10349))||
(v==0x1034A)
){ return id_scr_GOTHIC; }

if(((v>=0x10400)&&(v<=0x10425))||
((v>=0x10428)&&(v<=0x1044D))
){ return id_scr_DESERET; }

if(((v>=0x0300)&&(v<=0x034E))||
((v>=0x0360)&&(v<=0x0362))||
((v>=0x0488)&&(v<=0x0489))||
((v>=0x0591)&&(v<=0x05A1))||
((v>=0x05A3)&&(v<=0x05B9))||
((v>=0x05BB)&&(v<=0x05BD))||
(v==0x05BF)||
((v>=0x05C1)&&(v<=0x05C2))||
(v==0x05C4)||
((v>=0x064B)&&(v<=0x0655))||
(v==0x0670)||
((v>=0x06D6)&&(v<=0x06DC))||
((v>=0x06DD)&&(v<=0x06DE))||
((v>=0x06DF)&&(v<=0x06E4))||
((v>=0x06E7)&&(v<=0x06E8))||
((v>=0x06EA)&&(v<=0x06ED))||
((v>=0x20D0)&&(v<=0x20DC))||
((v>=0x20DD)&&(v<=0x20E0))||
(v==0x20E1)||
((v>=0x20E2)&&(v<=0x20E3))||
((v>=0x302A)&&(v<=0x302F))||
((v>=0x3099)&&(v<=0x309A))||
(v==0xFB1E)||
((v>=0xFE20)&&(v<=0xFE23))||
((v>=0x1D167)&&(v<=0x1D169))||
((v>=0x1D17B)&&(v<=0x1D182))||
((v>=0x1D185)&&(v<=0x1D18B))||
((v>=0x1D1AA)&&(v<=0x1D1AD))
){ return id_scr_INHERITED; }

	return id_scr_COMMON;

}