// Copyright  2002 Microsoft Corporation.  All rights reserved.

var last_meta_path_doc = null;
var last_meta_path_url = "";

function metapathobj() {

	this.url = "";
	this.idattribute = "";
	this.searchfilter = "";
	this.searchkeywords = "";
	this.searchcontexttitles = "";
	this.searchcontexts = new Array();

	this.populatefromfile = function( doc, url ) {
		this.url = url;
		var elm = null;
		var ns = null
		var att = "";

		att = doc.documentElement.getAttribute("id_attribute");
		if ( att ) this.idattribute = att;
		att = null;
		elm = null;
		elm = doc.documentElement.selectSingleNode( "./searchfilter" );
		if ( elm ) {
			att = elm.getAttribute("value");
			if ( att ) this.searchfilter = att;
		}

		att = null;
		elm = null;
		elm = doc.documentElement.selectSingleNode( "./searchkeywords" );
		if ( elm ) {	
			att = elm.getAttribute("value");
			if ( att ) this.searchkeywords = att;
		}
		
		att = null;
		elm = null;
		elm = doc.documentElement.selectSingleNode( "./searchcontexttitles" );
		if ( elm ) {
			att = elm.getAttribute("value");
			if ( att ) this.searchcontexttitles = att;
		}

		att = null;
		elm = null;
		ns = null;
		ns = doc.documentElement.selectNodes( "./searchcontext" );
		if ( ns ) {
			for( var i = 0; i < ns.length; i++ ) {
				if ( i == 0 ) this.searchcontexts.length = 0;
				elm = ns[i];
				att = elm.getAttribute("value");
				if ( att ) this.searchcontexts[this.searchcontexts.length] = att;
				att = null;
				elm = null;
			}
		}
	}
}

function getexternmetapathsref( doc ) {
	var node, att;
	node = doc.documentElement.selectSingleNode( "./head/meta[@mspress-internal-reference='searchmetapaths']" );
	if ( node == null ) node = doc.documentElement.selectSingleNode( "./Head/Meta[@mspress-internal-reference='searchmetapaths']" );
	if ( node == null ) node = doc.documentElement.selectSingleNode( "./HEAD/META[@mspress-internal-reference='searchmetapaths']" );
	if ( node ) {
		att = node.getAttribute("content");
		if ( att ) return att;
	}
	return null;
}

function loadmetatpaths( doc, url, in_searchxpathtitle, in_searchxpathelements ){
	if ( doc == null ) return null;
	var mp = new metapathobj();
	mp.idattribute = searchmetamodelidatt;
	if ( doc != null ){
		var extern_path = getexternmetapathsref( doc );
		if ( extern_path ) {
			if ( isrelativepath( extern_path ) ) extern_path = getbasepath( url ) + "/" + extern_path;		
			var xdoc = null;
			if ( last_meta_path_doc != null ){
				if ( extern_path == last_meta_path_url ) xdoc = last_meta_path_doc;
			}
			if ( !xdoc ) xdoc = xml_load( extern_path );
			if ( xdoc ) mp.populatefromfile( xdoc, extern_path );
		}
	}
	if (( mp.searchcontexttitles == "" ) && ( in_searchxpathtitle != null )) mp.searchcontexttitles = in_searchxpathtitle;
	if ( mp.searchcontexttitles == "" ) mp.searchcontexttitles = "//title | //Title | //TITLE";
	if ( mp.searchfilter == "" ) mp.searchfilter = "//script | //Script | //SCRIPT";
	if (( mp.searchcontexts.length == 0 ) && ( in_searchxpathelements != null )) mp.searchcontexts[mp.searchcontexts.length] = in_searchxpathelements;
	if ( mp.searchcontexts.length == 0 ) mp.searchcontexts[mp.searchcontexts.length] = "//" + doc.documentElement.nodeName;
	return mp;
}

function getkeywords( doc, xpat ) {
	var ns = doc.selectNodes( xpat );
	if ( ns ) {
		if ( ns.length != 0 ) return ns;
	}
	return null;
}

function isrelativepath( surl ){
	var surl2 = surl.toLowerCase();
	if (( surl2.indexOf("://") == -1 ) && ( surl2.indexOf("\\\\") == -1 ) && ( surl2.indexOf(":\\") == -1 )) return true;
	return false;
}
