// Copyright  2002 Microsoft Corporation.  All rights reserved.
function grep_escape( in_str ){
	var escapes = new Array( "\\", "-", "$", "(", ")", "*", "+", ".", "[", "?", "^", "{", "|");
	for ( var j = 0; j < in_str.length; j++ ) {
		var test = in_str.substr(j,1);
		for ( var k = 0; k < escapes.length; k++ ) {
			if ( escapes[k] == test ) {
				var rt = ""; var lft = "";
				if ( j != 0 ) lft = in_str.substr(0,j);
				if ( j + 1 < in_str.length ) rt =  in_str.substr(j+1);
				in_str = lft + "\\" + escapes[k] + rt;
				j++;
			}
		}
	}
	return in_str;
}
function getbasepath( str ) {
	var la; var lb;
	la = str.lastIndexOf("/");
	lb = str.lastIndexOf("\\");
	if ( la < lb ) la = lb;
	if ( la != 0 ) str = str.substr( 0, la );
	return str;
}

function normalspace( str ) {
	var output = "";
	var prevwhite = false;
	for( var i = 0; i < str.length; i++ ) {
		var c = str.charCodeAt( i );
		switch ( c ) {
			case 0x0009:
			case 0x000A:
			case 0x000B:
			case 0x000C:
			case 0x000D:
			case 0x000E:
			case 0x0020:
			case 0x00A0:
			case 0x2028:
			case 0x2029:
			case 0x115F:
			case 0x1160:
			case 0x2000:
			case 0x2001:
			case 0x2002:
			case 0x2003:
			case 0x2004:
			case 0x2005:
			case 0x2006:
			case 0x2007:
			case 0x2008:
			case 0x2009:
			case 0x200A:
			case 0x200B:
			case 0x3000:
			case 0x3164:
			case 0xFFA0:
				if ( prevwhite == false ) {
					output += " ";	
					prevwhite = true;
				}
				break;
			default:
				output += String.fromCharCode(c);
				prevwhite = false;
		}
	}
	return output;
}

function trim( instr ){
	if ( instr.length < 1 ) return "";
	var output = instr;
	for ( var i = 0; i < 2; i++ ) {
		var c;
		if ( i == 0 ) c = instr.charCodeAt( 0 );
		else c = instr.charCodeAt( instr.length-1 );
		while  (( c == 0x0009 )  ||
			( c == 0x000A )  ||
			( c == 0x000B )  ||
			( c == 0x000C )  ||
			( c == 0x000D )  ||
			( c == 0x000E )  ||
			( c == 0x0020 )  ||
			( c == 0x00A0 )  ||
			( c == 0x2028 )  ||
			( c == 0x2029 )  ||
			( c == 0x115F )  ||
			( c == 0x1160 )  ||
			( c == 0x2000 )  ||
			( c == 0x2001 )  ||
			( c == 0x2002 )  ||
			( c == 0x2003 )  ||
			( c == 0x2004 )  ||
			( c == 0x2005 )  ||
			( c == 0x2006 )  ||
			( c == 0x2007 )  ||
			( c == 0x2008 )  ||
			( c == 0x2009 )  ||
			( c == 0x200A )  ||
			( c == 0x200B )  ||
			( c == 0x2028 )  ||
			( c == 0x2029 )  ||
			( c == 0x3000 )  ||
			( c == 0x3164 )  ||
			( c == 0xFFA0 )  ){
			if ( output.length == 1 ) return "";
			if ( i == 0 ) {
				output = output.substr(1);
				c = output.charCodeAt( 0 );
			} else {
				output = output.substr(0, output.length - 1);
				c = output.charCodeAt( output.length - 1 );
			}
		}
	}
	return output;
}

function white_space_expression(){
return "[" + white_string() + "]+";
}
function white_string(){
return String.fromCharCode( 0x0009 ) +
String.fromCharCode( 0x000A ) +
String.fromCharCode( 0x000B ) +
String.fromCharCode( 0x000C ) +
String.fromCharCode( 0x000D ) +
String.fromCharCode( 0x000E ) +
String.fromCharCode( 0x0020 ) +
String.fromCharCode( 0x00A0 ) +
String.fromCharCode( 0x2028 ) +
String.fromCharCode( 0x2029 ) +
String.fromCharCode( 0x115F ) +
String.fromCharCode( 0x1160 ) +
String.fromCharCode( 0x2000 ) +
String.fromCharCode( 0x2001 ) +
String.fromCharCode( 0x2002 ) +
String.fromCharCode( 0x2003 ) +
String.fromCharCode( 0x2004 ) +
String.fromCharCode( 0x2005 ) +
String.fromCharCode( 0x2006 ) +
String.fromCharCode( 0x2007 ) +
String.fromCharCode( 0x2008 ) +
String.fromCharCode( 0x2009 ) +
String.fromCharCode( 0x200A ) +
String.fromCharCode( 0x200B ) +
String.fromCharCode( 0x3000 ) +
String.fromCharCode( 0x3164 ) +
String.fromCharCode( 0xFFA0 ) ;
}

function white_array(){
return new Array( String.fromCharCode( 0x000A ),
String.fromCharCode( 0x000B ),
String.fromCharCode( 0x000C ),
String.fromCharCode( 0x000D ),
String.fromCharCode( 0x000E ),
String.fromCharCode( 0x0020 ),
String.fromCharCode( 0x00A0 ),
String.fromCharCode( 0x2028 ),
String.fromCharCode( 0x2029 ),
String.fromCharCode( 0x115F ),
String.fromCharCode( 0x1160 ),
String.fromCharCode( 0x2000 ),
String.fromCharCode( 0x2001 ),
String.fromCharCode( 0x2002 ),
String.fromCharCode( 0x2003 ),
String.fromCharCode( 0x2004 ),
String.fromCharCode( 0x2005 ),
String.fromCharCode( 0x2006 ),
String.fromCharCode( 0x2007 ),
String.fromCharCode( 0x2008 ),
String.fromCharCode( 0x2009 ),
String.fromCharCode( 0x200A ),
String.fromCharCode( 0x200B ),
String.fromCharCode( 0x3000 ),
String.fromCharCode( 0x3164 ),
String.fromCharCode( 0xFFA0 ) );
}

function risswwe( in_string ){
	var retstr = "";
	var w_a = white_array();
	var strcopy = trim( in_string );
	var prev_white = false;
	for ( var j = 0; j < strcopy.length; j++ ) {
		var test = strcopy.substr(j,1);
		var b_rep = false;
		for ( var k = 0; k < w_a.length; k++ ) {
			if ( w_a[k] == test ) {
				if ( prev_white == false ) retstr += white_space_expression();
				b_rep = true;
				prev_white = true;
				break;
			}
		}
		if ( b_rep == false ) {
			prev_white = false;
			retstr+=test;
		}
	}
	return retstr;
}