
<!-- saved from url=(0014)about:internet -->
<xsl:stylesheet	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
		xmlns:msxsl="urn:schemas-microsoft-com:xslt"
		xmlns:user="http://mycompany.com/mynamespace">

<msxsl:script language="JScript" implements-prefix="user">

function spaceToScore( nodes ) {
	var s = nodes.nextNode().value;
	return s.replace( ' ', '_' );
}

</msxsl:script>

	<xsl:param name="bDisplayStatus" />
	
	<xsl:template match="/Root">
    		<xsl:for-each select="ContentItem">
			<xsl:if test="@ContentWheelIcon[.='']">  <!-- Do not render leaf nodes (topics) for Premium Courses-->
    			<xsl:element name="div">
				<xsl:variable name="sParentID" select="@ParentID"/>
				
    				<xsl:attribute name="name">Node</xsl:attribute>
    				<xsl:attribute name="Href"><xsl:value-of select="@Href" /></xsl:attribute>
    				<xsl:attribute name="id"><xsl:value-of select="@ID" /></xsl:attribute>			
    				<xsl:attribute name="HasChildren"><xsl:value-of select="@HasChildren" /></xsl:attribute>
    				<xsl:attribute name="ParentID"><xsl:value-of select="$sParentID" /></xsl:attribute>
				<xsl:attribute name="class">ContentItem</xsl:attribute>

				<xsl:element name="div">
					<xsl:attribute name="name">Parent</xsl:attribute>
    					<xsl:attribute name="id">__idParent</xsl:attribute>
					<xsl:attribute name="class">nodeParent</xsl:attribute>
  					<xsl:attribute name="title"><xsl:value-of select="@Name" /></xsl:attribute>

					<xsl:element name="table">
						<xsl:attribute name="id">__idTable</xsl:attribute>
						<xsl:attribute name="class">ItemLayoutTable</xsl:attribute>
						<xsl:attribute name="cellpadding">0</xsl:attribute>
						<xsl:attribute name="cellspacing">0</xsl:attribute>

					<xsl:element name="tr">
						<xsl:attribute name="valign">baseline</xsl:attribute>

					<xsl:element name="td">

					<xsl:element name="img">
    						<xsl:attribute name="name">__idItemStatusImg</xsl:attribute>
    						<xsl:attribute name="id">__idItemStatusImg</xsl:attribute>
    						<xsl:attribute name="align">absmiddle</xsl:attribute>
						<xsl:attribute name="vspace">2</xsl:attribute>
						
						<!-- Note: Use select="@LessonStatus" if using icons to denote status w/in TOC -->
						<xsl:variable name="lessonstatus" select="@LessonStatus"/>
    						<xsl:choose>

							<xsl:when test="$lessonstatus and $bDisplayStatus='true'">
								<xsl:attribute name="src">appart/<xsl:value-of select="user:spaceToScore( $lessonstatus )"/>.gif</xsl:attribute>
							</xsl:when>

    							<xsl:otherwise>
    								<xsl:attribute name="src">appart/block.gif</xsl:attribute>
    							</xsl:otherwise>
    						</xsl:choose>
    					</xsl:element>
					
					</xsl:element>
					<xsl:element name="td">

  					<xsl:element name="img">
						<xsl:attribute name="name">Item_Img</xsl:attribute>
    						<xsl:attribute name="id">__idItem_Img</xsl:attribute>
    						<xsl:attribute name="align">absmiddle</xsl:attribute>
						<xsl:attribute name="class">nodeImg</xsl:attribute>

						<xsl:choose>
							<xsl:when test="@CloseIcon">
								<xsl:attribute name="src"><xsl:value-of select="@CloseIcon"/></xsl:attribute>
    								<xsl:attribute name="img_collapse"><xsl:value-of select="@CloseIcon"/></xsl:attribute>
    								<xsl:attribute name="img_expand"><xsl:value-of select="@OpenIcon"/></xsl:attribute>
							</xsl:when>
    							<xsl:otherwise>
    								<xsl:attribute name="src"><xsl:value-of select="@LeafIcon"/></xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:element>
				
					</xsl:element>
  					<xsl:element name="td">
    					<xsl:element name='a'>
						<xsl:variable name="available" select="@Available" />
						<xsl:choose>
							<xsl:when test="$available='true'">
								<xsl:choose>
  									<xsl:when test="$sParentID=''">
										<xsl:attribute name="class">course</xsl:attribute>
										<xsl:attribute name="onmouseover">this.oldClass=this.className; this.className='courseHover'; window.status=' '; return true</xsl:attribute>
									</xsl:when>
    									<xsl:otherwise>
										<xsl:attribute name="class">node</xsl:attribute>
										<xsl:attribute name="onmouseover">this.oldClass=this.className; this.className='nodeHover'; window.status=' '; return true</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
  									<xsl:when test="$sParentID=''">
										<xsl:attribute name="class">courseUnavailable</xsl:attribute>
										<xsl:attribute name="onmouseover">this.oldClass='courseUnavailable'; this.className='courseUnavailable'; window.status=' '; return true</xsl:attribute>
									</xsl:when>
    									<xsl:otherwise>
										<xsl:attribute name="class">nodeUnavailable</xsl:attribute>
										<xsl:attribute name="onmouseover">this.oldClass='nodeUnavailable'; this.className='nodeUnavailable'; window.status=' '; return true</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:attribute name="onmouseout">this.className=this.oldClass; window.status=' '; return true</xsl:attribute>
						<xsl:attribute name="onmouseup">window.status=' '; return true</xsl:attribute>
						<xsl:attribute name="onmousedown">window.status=' '; return true</xsl:attribute>
						<xsl:attribute name="name">link</xsl:attribute>
    						<xsl:attribute name="id">__idLinkCaption</xsl:attribute>
						<xsl:attribute name="href"></xsl:attribute>
						<xsl:value-of select="@Name" />
    					</xsl:element>

					</xsl:element>
  					</xsl:element>
					</xsl:element>

				</xsl:element>

				<xsl:element name="div">
    					<xsl:attribute name="id">__idChildrenContainer</xsl:attribute>
					<xsl:attribute name="class">ChildrenContainer</xsl:attribute>
					<xsl:attribute name="style">display:none</xsl:attribute>
					<xsl:text> </xsl:text>
				</xsl:element>
			</xsl:element>	
			</xsl:if>	
    		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>